"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var PaginationComponent = (function () {
    function PaginationComponent() {
        this.pagesize = 10;
        this.selectedpage = 1;
        this.pagescount = 5;
        this.onPageChange = new core_1.EventEmitter();
    }
    PaginationComponent.prototype.ngOnInit = function () {
        this.SetPaging(this.selectedpage);
    };
    PaginationComponent.prototype.pageChange = function (selectedpage) {
        this.SetPaging(selectedpage);
        this.onPageChange.emit(selectedpage);
    };
    PaginationComponent.prototype.SetPaging = function (selectedpage) {
        if (this.totalrecords == undefined || this.totalrecords <= 0) {
            console.warn("source is empty");
            return;
        }
        this.selectedpage = parseInt(selectedpage.toString());
        this.totalpages = Math.ceil(this.totalrecords / this.pagesize);
        if (this.selectedpage > this.totalpages) {
            console.error("selectedpage cannot be greater than the total pages");
        }
        var min = Math.ceil((selectedpage - (this.pagescount / 2)) > 0
            ? (selectedpage - (this.pagescount / 2))
            : 1);
        var max = (min + parseInt(this.pagescount.toString())) > this.totalpages
            ? this.totalpages
            : (min + parseInt(this.pagescount.toString())) - 1;
        for (var i = 0; i < this.pagescount; i++) {
            if (((max - min) < (this.pagescount - 1)) && min > 1) {
                min = (min - 1);
            }
        }
        this.pages = Array(max - min + 1)
            .fill(max - min + 1)
            .map(function (x, i) { return min + i; });
    };
    return PaginationComponent;
}());
__decorate([
    core_1.Input("pagesize"),
    __metadata("design:type", Number)
], PaginationComponent.prototype, "pagesize", void 0);
__decorate([
    core_1.Input("totalrecords"),
    __metadata("design:type", Number)
], PaginationComponent.prototype, "totalrecords", void 0);
__decorate([
    core_1.Input("selectedpage"),
    __metadata("design:type", Number)
], PaginationComponent.prototype, "selectedpage", void 0);
__decorate([
    core_1.Input("pagescount"),
    __metadata("design:type", Number)
], PaginationComponent.prototype, "pagescount", void 0);
__decorate([
    core_1.Input("cssclass"),
    __metadata("design:type", String)
], PaginationComponent.prototype, "cssclass", void 0);
__decorate([
    core_1.Input("previousbtncss"),
    __metadata("design:type", String)
], PaginationComponent.prototype, "previousbtncss", void 0);
__decorate([
    core_1.Input("nextbtncss"),
    __metadata("design:type", String)
], PaginationComponent.prototype, "nextbtncss", void 0);
__decorate([
    core_1.Input("btncss"),
    __metadata("design:type", String)
], PaginationComponent.prototype, "btncss", void 0);
__decorate([
    core_1.Input("selectedcss"),
    __metadata("design:type", String)
], PaginationComponent.prototype, "selectedcss", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", Object)
], PaginationComponent.prototype, "onPageChange", void 0);
PaginationComponent = __decorate([
    core_1.Component({
        moduleId: module.id.replace('jscode', 'app'),
        selector: 'pagination',
        template: "\n    <div *ngIf=\"pages\" [ngClass]=\"[cssclass===undefined? 'custompagination' :cssclass]\">\n      <ul>\n        <li>\n          <button [disabled]=\"selectedpage === 1\" (click)=pageChange(selectedpage-1) [ngClass]=\"[previousbtncss===undefined? 'btn btn-primary glyphicon glyphicon-menu-left': previousbtncss ]\">\n          </button>\n        </li>\n        <li *ngFor=\"let page of pages\" (click)=pageChange(page)>\n          <button [ngClass]=\"[btncss===undefined? 'btn': btncss, page===selectedpage ? selectedcss ===undefined?'btn-primary':selectedcss : '']\">\n            {{page}}\n          </button>\n        </li>\n        <li>\n          <button [disabled]=\"selectedpage === totalpages\" (click)=pageChange(selectedpage+1) [ngClass]=\"[nextbtncss===undefined? 'btn btn-primary glyphicon glyphicon-menu-right': nextbtncss ]\">\n          </button>\n        </li>\n      </ul>\n    </div>\n  ",
        styles: ["\n    /*pagging******************************************************************************/\n\n    .custompagination ul li {\n        list-style-type: none;\n        margin: 0;\n        padding: 0;\n        display: inline;\n    }\n\n    .custompagination ul li .mat-raised-button,\n    .custompagination ul li .mat-button {\n        min-width: 0 !important;\n    }\n\n\n    /**************************************************************************************/\n  "]
    }),
    __metadata("design:paramtypes", [])
], PaginationComponent);
exports.PaginationComponent = PaginationComponent;
